// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, log, sop, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  sop = require('./sop');

  log = require('../../qeda-log');

  module.exports = function(pattern, element) {
    var bodyLength, bodyWidth, courtyard, d, firstPad, height, housing, i, j, lastPad, leftCount, lineWidth, pad, padParams, ref, ref1, settings, x, x1, x2, y, y1, y2, y3;
    housing = element.housing;
    height = (ref = housing.height.max) != null ? ref : housing.height;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["SOT%dP%dX%d-%d"].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, height * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this)))));
    }
    settings = pattern.settings;
    if ((housing.leadCount === 6) || (housing.leadCount === 8)) {
      return sop(pattern, element);
    } else {
      padParams = calculator.sop(pattern, housing);
      switch (housing.leadCount) {
        case 3:
          leftCount = 1;
          break;
        case 5:
          leftCount = 3;
          break;
        default:
          log.error("Wrong lead count (" + housing.leadCount + ")");
      }
      pad = {
        type: 'smd',
        shape: 'rectangle',
        width: padParams.width,
        height: padParams.height,
        layer: ['topCopper', 'topMask', 'topPaste']
      };
      pad.x = -padParams.distance / 2;
      y = -housing.pitch * (leftCount / 2 - 0.5);
      for (i = j = 1, ref1 = leftCount; 1 <= ref1 ? j <= ref1 : j >= ref1; i = 1 <= ref1 ? ++j : --j) {
        pad.y = y;
        pattern.pad(i, pad);
        y += housing.pitch;
      }
      pad.x = padParams.distance / 2;
      pad.y = housing.pitch;
      pattern.pad(leftCount + 1, pad);
      pad.y -= 2 * housing.pitch;
      pattern.pad(leftCount + 2, pad);
      firstPad = pattern.pads[1];
      lastPad = pattern.pads[housing.leadCount];
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      x = bodyWidth / 2 + lineWidth / 2;
      y1 = -bodyLength / 2 - lineWidth / 2;
      y2 = firstPad.y - firstPad.height / 2 - lineWidth / 2 - settings.clearance.padToSilk;
      if (y1 > y2) {
        y1 = y2;
      }
      y3 = lastPad.y + lastPad.height / 2 + lineWidth / 2 + settings.clearance.padToSilk;
      pattern.layer('topSilkscreen').lineWidth(lineWidth).attribute('refDes', {
        x: 0,
        y: 0,
        angle: 90,
        halign: 'center',
        valign: 'center'
      }).moveTo(x, y2).lineTo(x, y1).lineTo(-x, y1).lineTo(-x, y2).lineTo(-x - firstPad.width, y2).moveTo(x, -y2).lineTo(x, -y1).lineTo(-x, -y1).lineTo(-x, -y2).line(x, -y3, x, y3).polarityMark(firstPad.x - firstPad.width / 2 - settings.clearance.padToSilk, firstPad.y);
      x = bodyWidth / 2;
      y = bodyLength / 2;
      d = 1;
      pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('value', {
        text: pattern.name,
        x: 0,
        y: y + settings.fontSize.value / 2 + 0.5,
        halign: 'center',
        valign: 'center',
        visible: false
      }).moveTo(-x + d, -y).lineTo(x, -y).lineTo(x, y).lineTo(-x, y).lineTo(-x, -y + d).lineTo(-x + d, -y);
      courtyard = padParams.courtyard;
      x1 = -bodyWidth / 2 - courtyard;
      y1 = -bodyLength / 2 - courtyard;
      x2 = firstPad.x - firstPad.width / 2 - courtyard;
      y2 = firstPad.y - firstPad.height / 2 - courtyard;
      if (y1 > y2) {
        y1 = y2;
      }
      return pattern.layer('topCourtyard').lineWidth(settings.lineWidth.courtyard).circle(0, 0, 0.5).line(-0.7, 0, 0.7, 0).line(0, -0.7, 0, 0.7).moveTo(x1, y1).lineTo(x1, y2).lineTo(x2, y2).lineTo(x2, -y2).lineTo(x1, -y2).lineTo(x1, -y2).lineTo(x1, -y1).lineTo(-x1, -y1).lineTo(-x1, -y2).lineTo(-x2, -y2).lineTo(-x2, y2).lineTo(-x1, y2).lineTo(-x1, y1).lineTo(x1, y1);
    }
  };

}).call(this);
